SFML - Simple and Fast Multimedia Library

SFML 2.6.1

- Main Page
- Related Pages
- Topics
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Protected Attributes | List of all members
sf::Sound Class Reference
Audio module

Regular sound that can be played in the audio environment. More...

`#include <SFML/Audio/Sound.hpp>`

Inheritance diagram for sf::Sound:

## Public Types
enum | Status { Stopped , Paused , Playing }
| Enumeration of the sound source states. More...

## Public Member Functions
| Sound ()
| Default constructor.
| Sound (const SoundBuffer &buffer)
| Construct the sound with a buffer.
| Sound (const Sound &copy)
| Copy constructor.
| ~Sound ()
| Destructor.
void | play ()
| Start or resume playing the sound.
void | pause ()
| Pause the sound.
void | stop ()
| stop playing the sound
void | setBuffer (const SoundBuffer &buffer)
| Set the source buffer containing the audio data to play.
void | setLoop (bool loop)
| Set whether or not the sound should loop after reaching the end.
void | setPlayingOffset (Time timeOffset)
| Change the current playing position of the sound.
const SoundBuffer * | getBuffer () const
| Get the audio buffer attached to the sound.
bool | getLoop () const
| Tell whether or not the sound is in loop mode.
Time | getPlayingOffset () const
| Get the current playing position of the sound.
Status | getStatus () const
| Get the current status of the sound (stopped, paused, playing)
Sound & | operator= (const Sound &right)
| Overload of assignment operator.
void | resetBuffer ()
| Reset the internal buffer of the sound.
void | setPitch (float pitch)
| Set the pitch of the sound.
void | setVolume (float volume)
| Set the volume of the sound.
void | setPosition (float x, float y, float z)
| Set the 3D position of the sound in the audio scene.
void | setPosition (const Vector3f &position)
| Set the 3D position of the sound in the audio scene.
void | setRelativeToListener (bool relative)
| Make the sound's position relative to the listener or absolute.
void | setMinDistance (float distance)
| Set the minimum distance of the sound.
void | setAttenuation (float attenuation)
| Set the attenuation factor of the sound.
float | getPitch () const
| Get the pitch of the sound.
float | getVolume () const
| Get the volume of the sound.
Vector3f | getPosition () const
| Get the 3D position of the sound in the audio scene.
bool | isRelativeToListener () const
| Tell whether the sound's position is relative to the listener or is absolute.
float | getMinDistance () const
| Get the minimum distance of the sound.
float | getAttenuation () const
| Get the attenuation factor of the sound.

## Protected Attributes
unsigned int | m_source
| OpenAL source identifier.

## Detailed Description

Regular sound that can be played in the audio environment.

sf::Sound is the class to use to play sounds.

It provides:

- Control (play, pause, stop)
- Ability to modify output parameters in real-time (pitch, volume, ...)
- 3D spatial features (position, attenuation, ...).

sf::Sound is perfect for playing short sounds that can fit in memory and require no latency, like foot steps or gun shots. For longer sounds, like background musics or long speeches, rather see sf::Music (which is based on streaming).

In order to work, a sound must be given a buffer of audio data to play. Audio data (samples) is stored in sf::SoundBuffer, and attached to a sound with the setBuffer() function. The buffer object attached to a sound must remain alive as long as the sound uses it. Note that multiple sounds can use the same sound buffer at the same time.

Usage example:

sf::SoundBuffer buffer;
buffer.loadFromFile("sound.wav");
sf::Sound sound;
sound.setBuffer(buffer);
sound.play();
sf::SoundBuffer
Storage for audio samples defining a sound.
Definition SoundBuffer.hpp:50
sf::SoundBuffer::loadFromFile
bool loadFromFile(const std::string &filename)
Load the sound buffer from a file.
sf::Sound
Regular sound that can be played in the audio environment.
Definition Sound.hpp:46
sf::Sound::play
void play()
Start or resume playing the sound.
sf::Sound::setBuffer
void setBuffer(const SoundBuffer &buffer)
Set the source buffer containing the audio data to play.

See also
  sf::SoundBuffer, sf::Music

Definition at line 45 of file Sound.hpp.

## Member Enumeration Documentation

## ◆ Status

enum sf::SoundSource::Status
| inherited

Enumeration of the sound source states.

Enumerator
Stopped | Sound is not playing.
Paused | Sound is paused.
Playing | Sound is playing.

Definition at line 50 of file SoundSource.hpp.

## Constructor & Destructor Documentation

## ◆ Sound() [1/3]

sf::Sound::Sound | ( |  | ) |

Default constructor.

## ◆ Sound() [2/3]

sf::Sound::Sound | ( | const SoundBuffer & | buffer | ) |
| explicit

Construct the sound with a buffer.

Parameters

  buffer | Sound buffer containing the audio data to play with the sound

## ◆ Sound() [3/3]

sf::Sound::Sound | ( | const Sound & | copy | ) |

Copy constructor.

Parameters

  copy | Instance to copy

## ◆ ~Sound()

sf::Sound::~Sound | ( |  | ) |

Destructor.

## Member Function Documentation

## ◆ getAttenuation()

float sf::SoundSource::getAttenuation | ( |  | ) | const
| inherited

Get the attenuation factor of the sound.

Returns
  Attenuation factor of the sound

See also
  setAttenuation, getMinDistance

## ◆ getBuffer()

const SoundBuffer * sf::Sound::getBuffer | ( |  | ) | const

Get the audio buffer attached to the sound.

Returns
  Sound buffer attached to the sound (can be NULL)

## ◆ getLoop()

bool sf::Sound::getLoop | ( |  | ) | const

Tell whether or not the sound is in loop mode.

Returns
  True if the sound is looping, false otherwise

See also
  setLoop

## ◆ getMinDistance()

float sf::SoundSource::getMinDistance | ( |  | ) | const
| inherited

Get the minimum distance of the sound.

Returns
  Minimum distance of the sound

See also
  setMinDistance, getAttenuation

## ◆ getPitch()

float sf::SoundSource::getPitch | ( |  | ) | const
| inherited

Get the pitch of the sound.

Returns
  Pitch of the sound

See also
  setPitch

## ◆ getPlayingOffset()

Time sf::Sound::getPlayingOffset | ( |  | ) | const

Get the current playing position of the sound.

Returns
  Current playing position, from the beginning of the sound

See also
  setPlayingOffset

## ◆ getPosition()

Vector3f sf::SoundSource::getPosition | ( |  | ) | const
| inherited

Get the 3D position of the sound in the audio scene.

Returns
  Position of the sound

See also
  setPosition

## ◆ getStatus()

Status sf::Sound::getStatus | ( |  | ) | const
| virtual

Get the current status of the sound (stopped, paused, playing)

Returns
  Current status of the sound

Reimplemented from sf::SoundSource.

## ◆ getVolume()

float sf::SoundSource::getVolume | ( |  | ) | const
| inherited

Get the volume of the sound.

Returns
  Volume of the sound, in the range [0, 100]

See also
  setVolume

## ◆ isRelativeToListener()

bool sf::SoundSource::isRelativeToListener | ( |  | ) | const
| inherited

Tell whether the sound's position is relative to the listener or is absolute.

Returns
  True if the position is relative, false if it's absolute

See also
  setRelativeToListener

## ◆ operator=()

Sound & sf::Sound::operator= | ( | const Sound & | right | ) |

Overload of assignment operator.

Parameters

  right | Instance to assign

Returns
  Reference to self

## ◆ pause()

void sf::Sound::pause | ( |  | ) |
| virtual

Pause the sound.

This function pauses the sound if it was playing, otherwise (sound already paused or stopped) it has no effect.

See also
  play, stop

Implements sf::SoundSource.

## ◆ play()

void sf::Sound::play | ( |  | ) |
| virtual

Start or resume playing the sound.

This function starts the stream if it was stopped, resumes it if it was paused, and restarts it from beginning if it was it already playing. This function uses its own thread so that it doesn't block the rest of the program while the sound is played.

See also
  pause, stop

Implements sf::SoundSource.

## ◆ resetBuffer()

void sf::Sound::resetBuffer | ( |  | ) |

Reset the internal buffer of the sound.

This function is for internal use only, you don't have to use it. It is called by the sf::SoundBuffer that this sound uses, when it is destroyed in order to prevent the sound from using a dead buffer.

## ◆ setAttenuation()

void sf::SoundSource::setAttenuation | ( | float | attenuation | ) |
| inherited

Set the attenuation factor of the sound.

The attenuation is a multiplicative factor which makes the sound more or less loud according to its distance from the listener. An attenuation of 0 will produce a non-attenuated sound, i.e. its volume will always be the same whether it is heard from near or from far. On the other hand, an attenuation value such as 100 will make the sound fade out very quickly as it gets further from the listener. The default value of the attenuation is 1.

Parameters

  attenuation | New attenuation factor of the sound

See also
  getAttenuation, setMinDistance

## ◆ setBuffer()

void sf::Sound::setBuffer | ( | const SoundBuffer & | buffer | ) |

Set the source buffer containing the audio data to play.

It is important to note that the sound buffer is not copied, thus the sf::SoundBuffer instance must remain alive as long as it is attached to the sound.

Parameters

  buffer | Sound buffer to attach to the sound

See also
  getBuffer

## ◆ setLoop()

void sf::Sound::setLoop | ( | bool | loop | ) |

Set whether or not the sound should loop after reaching the end.

If set, the sound will restart from beginning after reaching the end and so on, until it is stopped or setLoop(false) is called. The default looping state for sound is false.

Parameters

  loop | True to play in loop, false to play once

See also
  getLoop

## ◆ setMinDistance()

void sf::SoundSource::setMinDistance | ( | float | distance | ) |
| inherited

Set the minimum distance of the sound.

The "minimum distance" of a sound is the maximum distance at which it is heard at its maximum volume. Further than the minimum distance, it will start to fade out according to its attenuation factor. A value of 0 ("inside the head of the listener") is an invalid value and is forbidden. The default value of the minimum distance is 1.

Parameters

  distance | New minimum distance of the sound

See also
  getMinDistance, setAttenuation

## ◆ setPitch()

void sf::SoundSource::setPitch | ( | float | pitch | ) |
| inherited

Set the pitch of the sound.

The pitch represents the perceived fundamental frequency of a sound; thus you can make a sound more acute or grave by changing its pitch. A side effect of changing the pitch is to modify the playing speed of the sound as well. The default value for the pitch is 1.

Parameters

  pitch | New pitch to apply to the sound

See also
  getPitch

## ◆ setPlayingOffset()

void sf::Sound::setPlayingOffset | ( | Time | timeOffset | ) |

Change the current playing position of the sound.

The playing position can be changed when the sound is either paused or playing. Changing the playing position when the sound is stopped has no effect, since playing the sound will reset its position.

Parameters

  timeOffset | New playing position, from the beginning of the sound

See also
  getPlayingOffset

## ◆ setPosition() [1/2]

void sf::SoundSource::setPosition | ( | const Vector3f & | position | ) |
| inherited

Set the 3D position of the sound in the audio scene.

Only sounds with one channel (mono sounds) can be spatialized. The default position of a sound is (0, 0, 0).

Parameters

  position | Position of the sound in the scene

See also
  getPosition

## ◆ setPosition() [2/2]

void sf::SoundSource::setPosition | ( | float | x,
|  | float | y,
|  | float | z
| ) |  |
| inherited

Set the 3D position of the sound in the audio scene.

Only sounds with one channel (mono sounds) can be spatialized. The default position of a sound is (0, 0, 0).

Parameters

  x | X coordinate of the position of the sound in the scene
  y | Y coordinate of the position of the sound in the scene
  z | Z coordinate of the position of the sound in the scene

See also
  getPosition

## ◆ setRelativeToListener()

void sf::SoundSource::setRelativeToListener | ( | bool | relative | ) |
| inherited

Make the sound's position relative to the listener or absolute.

Making a sound relative to the listener will ensure that it will always be played the same way regardless of the position of the listener. This can be useful for non-spatialized sounds, sounds that are produced by the listener, or sounds attached to it. The default value is false (position is absolute).

Parameters

  relative | True to set the position relative, false to set it absolute

See also
  isRelativeToListener

## ◆ setVolume()

void sf::SoundSource::setVolume | ( | float | volume | ) |
| inherited

Set the volume of the sound.

The volume is a value between 0 (mute) and 100 (full volume). The default value for the volume is 100.

Parameters

  volume | Volume of the sound

See also
  getVolume

## ◆ stop()

void sf::Sound::stop | ( |  | ) |
| virtual

stop playing the sound

This function stops the sound if it was playing or paused, and does nothing if it was already stopped. It also resets the playing position (unlike pause()).

See also
  play, pause

Implements sf::SoundSource.

## Member Data Documentation

## ◆ m_source

unsigned int sf::SoundSource::m_source
| protectedinherited

OpenAL source identifier.

Definition at line 309 of file SoundSource.hpp.

The documentation for this class was generated from the following file:

- Sound.hpp